<template>
  <div class="mx-auto px-10 py-6">
    <div class="max-w-7xl mx-auto px-4 sm:px-6 md:px-8">
      <h1 class="text-2xl font-semibold text-gray-900">Users</h1>
    </div>
    <div class="overflow-hidden shadow rounded-lg my-6">
    <div class="sm:hidden">
        <label for="tabs" class="sr-only">Select a tab</label>
        <select id="tabs" name="tabs" class="block w-full focus:ring-yellow-500 focus:border-yellow-500 border-gray-300 rounded-md">
            <option>Application</option>
            <option>Entrepreneur</option>
            <option>Sponsors</option>
        </select>
    </div>
    <div class="hidden sm:block">
        <div class="border-b border-gray-200">
        <nav class="-mb-px flex" aria-label="Tabs">
            <span v-on:click="filter = 'default'" to="/dashboard/users/application" class="border-transparent text-gray-500 hover:text-gray-700 hover:border-gray-300 w-1/3 py-4 px-1 text-center border-b-2 font-medium text-sm cursor-pointer">
                All Users
            </span>
            <span v-on:click="filter = 'application'" to="/dashboard/users/application" class="border-transparent text-gray-500 hover:text-gray-700 hover:border-gray-300 w-1/3 py-4 px-1 text-center border-b-2 font-medium text-sm cursor-pointer">
                Application
            </span>
            <span v-on:click="filter = 'entrepreneur'" to="/dashboard/users/application" class="border-transparent text-gray-500 hover:text-gray-700 hover:border-gray-300 w-1/3 py-4 px-1 text-center border-b-2 font-medium text-sm cursor-pointer">
                Entrepreneur
            </span>
            <span v-on:click="filter = 'sponsors'" to="/dashboard/users/application" class="border-transparent text-gray-500 hover:text-gray-700 hover:border-gray-300 w-1/3 py-4 px-1 text-center border-b-2 font-medium text-sm cursor-pointer">
                Sponsors
            </span>
        </nav>
        </div>
    </div>
    <div class="hidden sm:block">
        <div class="align-middle inline-block min-w-full border-b border-gray-200">
          <table class="min-w-full">
            <thead>
              <tr class="border-t border-gray-200">
                <th class="px-6 py-3 border-b border-gray-200 bg-gray-50 text-left text-xs font-medium text-gray-500 uppercase tracking-wider">
                  <span class="lg:pl-2">Name</span>
                </th>
                <th class="px-6 py-3 border-b border-gray-200 bg-gray-50 text-left text-xs font-medium text-gray-500 uppercase tracking-wider">
                  Role
                </th>
                <th class="hidden md:table-cell px-6 py-3 border-b border-gray-200 bg-gray-50 text-xs font-medium text-gray-500 uppercase tracking-wider">
                  Status
                </th>
                <th class="pr-6 py-3 border-b border-gray-200 bg-gray-50 text-right text-xs font-medium text-gray-500 uppercase tracking-wider"></th>
              </tr>
            </thead>
            <tbody class="bg-white divide-y divide-gray-100">
              <tr v-for="(user, index) in allUser" :key="index">
                <td class="px-6 py-3 max-w-0 w-full whitespace-nowrap text-sm font-medium text-gray-900">
                  <div class="flex items-center space-x-3 lg:pl-2">
                    <span class="inline-flex items-center justify-center h-6 w-6 rounded-full bg-gray-500">
                      <span class="text-xs font-medium leading-none text-white">{{user.name.substring(0, 2)}}</span>
                    </span>
                    <router-link :to="{name: 'UsersProfil', params: {id: user.id}}" href="#" class="truncate hover:text-gray-600">
                      <span>
                        {{user.name}}
                      </span>
                    </router-link>
                  </div>
                </td>
                <td class="px-6 py-3 text-sm text-gray-500 font-medium">
                  {{getRoleString(user.roles)}}
                </td>
                <td class="hidden md:table-cell px-6 py-3 whitespace-nowrap text-sm text-gray-500 text-right">
                  <span class="inline-flex items-center px-2.5 py-0.5 rounded-full text-xs font-medium bg-gray-100 text-gray-800">
                    {{getStatusString(user.status)}}
                  </span>
                </td>
                <td class="pr-6">
                  <router-link :to="{name: 'UsersProfil', params: {id: user.id}}" class="inline-flex items-center px-3 py-2 border border-transparent text-sm leading-4 font-medium rounded-md shadow-sm text-white bg-yellow-500 hover:bg-yellow-700 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-yellow-500">
                    See
                  </router-link>
                </td>
              </tr>
            </tbody>
          </table>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { mapGetters, mapActions } from 'vuex'
export default {
  name: 'Users',
  data () {
    return {
      filter: '',
      allUser: []
    }
  },
  computed: {
    ...mapGetters('user', ['all'])
  },
  watch: {
    filter: function (newFilter, oldFilter) {
      console.log(newFilter)
      switch (newFilter) {
        case 'application':
          this.allUser = this.all.filter(user => user.status <= 2)
          break
        case 'entrepreneur':
          this.allUser = this.all.filter(user => user.roles.includes('ROLE_USER'))
          break
        case 'sponsors':
          this.allUser = this.all.filter(user => user.roles.includes('ROLE_USER'))
          break
        default:
          this.allUser = this.all
      }
    }
  },
  methods: {
    ...mapActions('user', ['fetchAll']),
    getRoleString (roles) {
      if (roles.includes('ROLE_ADMIN')) {
        return 'Administrator'
      } else if (roles.includes('ROLE_USER')) {
        return 'User'
      }
    },
    getStatusString (status) {
      if (status <= 2) {
        return 'Pending'
      } else {
        return 'Activate'
      }
    }
  },
  async beforeMount () {
    await this.fetchAll()
    this.allUser = this.all
  }
}
</script>
